/***************************************************************************
 *  Title: Linked List Example 
 * -------------------------------------------------------------------------
 *    Purpose: A simple linked list example
 *    Author: Stefan Birrer
 *    Version: $Revision: 1.1 $
 *    Last Modification: $Date: 2003/09/30 16:22:21 $
 *    File: $RCSfile: llist.c,v $
 *    Copyright: 2003 by Stefan Birrer
 ***************************************************************************/
/***************************************************************************
 *  ChangeLog:
 * -------------------------------------------------------------------------
 *    $Log: llist.c,v $
 *    Revision 1.1  2003/09/30 16:22:21  sbirrer
 *    - simple linked list example
 *
 ***************************************************************************/
	#define __LLIST_IMPL__

  /************System include***********************************************/
	#include <stdio.h>
	#include <stdlib.h>
	#include <assert.h>

  /************Private include**********************************************/
	#include "llist.h"

  /************Defines and Typedefs*****************************************/
    /*  #defines and typedefs should have their names in all caps.
     *  Global variables begin with g. Global constants with k. Local
     *  variables should be in all lower case. When initializing
     *  structures and arrays, line everything up in neat columns.
     */
	#define MESSAGE	"hello world!"

  /************Global Variables*********************************************/
	// This static variable is accessible from within all methods in this 
	// function, but not from other files. This is the prefered way for
	// static variables shared among multiple functions (i.e. mutexes).
	// In general this is the most exposed variable you should use in any
	// projects. If you need to go further than this, you may think of
	// revisiting the design of your project.
	
  /************Function Prototypes******************************************/

  /************External Declaration*****************************************/

/**************Implementation***********************************************/

llistT *createEntry(llistT *prev)
{
	llistT *temp = (struct llist*) malloc(sizeof(llistT));

	if (prev)
	{
		temp->next = prev->next;
		prev->next = temp;
	}
	else
	{
		temp->next = NULL;
	}

	return temp;
}

void dispose(llistT *first)
{
	assert(first != NULL);
	llistT *cur = first;

	while (cur != NULL)
	{
		llistT *next = cur->next;
		free(cur);
		cur = next;
	}
}

void dump(const llistT *first)
{
	assert(first != NULL);
	const llistT *cur = first;

	while (cur != NULL)
	{
		printf("%d ", cur->id);
		cur = cur->next;
	}

	printf("\n");
}
