/***************************************************************************
 *  Title: Linked List Example
 * -------------------------------------------------------------------------
 *    Purpose: A simple linked list example
 *    Author: Stefan Birrer
 *    Version: $Revision: 1.1 $
 *    Last Modification: $Date: 2003/09/30 16:22:21 $
 *    File: $RCSfile: llist.h,v $
 *    Copyright: 2003 by Stefan Birrer
 ***************************************************************************/
/***************************************************************************
 *  ChangeLog:
 * -------------------------------------------------------------------------
 *    $Log: llist.h,v $
 *    Revision 1.1  2003/09/30 16:22:21  sbirrer
 *    - simple linked list example
 *
 ***************************************************************************/

#ifndef __LLIST_H__
#define __LLIST_H__

	#ifdef HAVE_CONFIG_H
	#include "config.h"
	#endif

  /************System include***********************************************/

  /************Private include**********************************************/

  /************Defines and Typedefs*****************************************/
    /*  #defines and typedefs should have their names in all caps.
     *  Global variables begin with g. Global constants with k. Local
     *  variables should be in all lower case. When initializing
     *  structures and arrays, line everything up in neat columns.
     */

	#undef EXTERN
	#ifdef __HELLO_IMPL__
		#define EXTERN 
	#else
		#define EXTERN extern
	#endif

	struct llist
	{
		int id;
		struct llist *next;
	};

	typedef struct llist llistT;

  /************Global Variables*********************************************/

  /************Function Prototypes******************************************/
	
	/***********************************************************************
	 *  Title: Create one entry.  
	 * ---------------------------------------------------------------------
	 *    Purpose: Create one linked list entry.
	 *    Input: the previous entry
	 *    Output: the created entry
	 ***********************************************************************/
	EXTERN llistT *createEntry(llistT *prev);

	/***********************************************************************
	 *  Title: Dispose the linked list.  
	 * ---------------------------------------------------------------------
	 *    Purpose: Free the allocated resources.
	 *    Input: the beginning of the list
	 *    Output: void
	 ***********************************************************************/
	EXTERN void dispose(llistT *first);

	/***********************************************************************
	 *  Title: Dump the linked list.  
	 * ---------------------------------------------------------------------
	 *    Purpose: Dump the linked list to stdout.
	 *    Input: the beginning of the list
	 *    Output: void
	 ***********************************************************************/
	EXTERN void dump(const llistT *first);	

#endif /* __LLIST_H__ */
